#ifndef _MOT_MAZE_H
#define _MOT_MAZE_H

#define N_WALL          0x1
#define E_WALL          0x2
#define S_WALL          0x4
#define W_WALL          0x8

typedef unsigned char   MCELL;

struct
{
   MCELL *data;

   /*
    * w and h are the "data w": not the number of cells in a row or
    * column, but the number of cells AND walls in a row or column.
    */
   size_t w, h;

   /*
    * Cell width and height of the maze, not counting walls (on the
    * server/generator), width and height in pixels of the maze (in the
    * client).
    */
   unsigned int width, height;

   /*
    * The killer's/drunkard's/maze carver's current X and Y position in
    * the generator. The maze's top left corner in the client.
    */
   unsigned int X, Y;

   /*
    * Data size of the maze representation, in bytes.
    */
   size_t size;
} MAZE;

#ifdef _MOT_SERVER
void genmaze(unsigned int width, unsigned int height);
#endif

#endif
